


function toggleRow (elt)
{
	if (elt == null)
		return;

	var eltLink = elt.firstChild;

  /* ignore text nodes */ 
  if(eltLink != null && eltLink.nodeType == 3) {
    eltLink = eltLink.nextSibling;
  }

  if (eltLink != null && eltLink.className == 'expansionIcon')	// toggle
	{
		var ich = elt.className.indexOf ('_');
		if (ich < 0)
		{
			eltLink.src = 'resources/tp.gif';
			elt.className += '_';
		}
		else
		{
			eltLink.src = 'resources/tm.gif';
			elt.className = elt.className.slice (0, ich);
		}
	}
}

function toggleTable(elt)
{
	if (elt == null)
		return;
	lt = elt.nextSibling;

  /* ignore text nodes */ 
  if(elt != null && elt.nodeType == 3) {
    elt = elt.nextSibling;
  }


  if(elt != null && (elt.className == 'table' || elt.className == 'table_')) {
    var ich = elt.className.indexOf ('_');
		if (ich < 0)
		{
			elt.className += '_';
		}
		else
		{
			elt.className = elt.className.slice (0, ich);
		}
	}

  /* see if there is a documentation table to toggle too */
	elt = elt.nextSibling;

  /* ignore text nodes */ 
  if(elt != null && elt.nodeType == 3) {
    elt = elt.nextSibling;
  }


  if(elt != null && (elt.className == 'table' || elt.className == 'table_')) {
    var ich = elt.className.indexOf ('_');
		if (ich < 0)
		{
			elt.className += '_';
		}
		else
		{
			elt.className = elt.className.slice (0, ich);
		}
	}
}

function getParentDiv (elt)
{
  if (elt)
  {
    do
    {
      elt = elt.parentNode;
    }
    while (elt && elt.tagName != 'DIV');
  }

  return elt;
}


function expandTreeItem(elt) 
{
  if(!elt) {
    return; 
  }

	var eltLink = elt.firstChild;

  /* ignore text nodes */ 
  if(eltLink != null && eltLink.nodeType == 3) {
    eltLink = eltLink.nextSibling;
  }

  var ich = elt.className.indexOf ('_');
  if (ich >= 0)
  {
    if (eltLink != null && eltLink.className == 'expansionIcon')	// toggle
			eltLink.src = 'resources/tm.gif';
    elt.className = elt.className.slice (0, ich);
  }
  else {
    // Save time by not expanding parents if they're already expanded.
    // This works only because we collapse the entire tree to start with.
    return;
  }

  expandTreeItem(getParentDiv(elt));


}

function collapseAllNodes() {
    var divs = document.getElementsByTagName("div");

    // Collapse the whole tree
    for(i = 0; i < divs.length; i++) 
    {
      var div = divs.item(i);
      var ich = div.className.indexOf ('_');
      if (ich < 0)
      {
        div.className += "_";

				var eltLink = div.firstChild;

			  /* ignore text nodes */ 
			  if(eltLink != null && eltLink.nodeType == 3) {
		  	  eltLink = eltLink.nextSibling;
			  }

			  if (eltLink != null && eltLink.className == 'expansionIcon')	// toggle icon to closed
				{
			    eltLink.src = 'resources/tp.gif';
        }
      }
      
    }
}


function clearHighlighting() 
{
    var children = document.getElementsByTagName("span");

    // Search
    for(i = 0; i < children.length; i++) 
    {
      var span = children.item(i);
      if(!span) { 
        continue; 
      }
      if(span.className == "itemName_") {
        span.className = "itemName";
      }
	  }
}

function doExpandNodeCalled(name, j) 
{

    var children = document.getElementsByTagName("span");

    // Search
    for(i = j; i < children.length; i++) 
    {
      var span = children.item(i);
      if(!span) { 
        continue; 
      }
      if(span.className == "itemName_") {
        span.className = "itemName";
      }
      if(!name) {
        continue;
      }

      var name;
      if(span.innerText) {
        itemName = span.innerText;
      }
      else {
        itemName = span.firstChild.nodeValue;
      }
      
      if(itemName && itemName.toLowerCase().indexOf(name.toLowerCase()) >= 0) {
        expandTreeItem(getParentDiv(getParentDiv(children.item(i))));
        span.className = "itemName_";
      }
      if(i != j && i % 100 == 0) {
        //document.getElementsByName("percentage").item(0).firstChild.nodeValue = Math.floor((i / children.length) * 10000) / 100;
        setTimeout("doExpandNodeCalled('" + name + "', '" + i + "');", 10);
        return;
      }
    
    }

}

function expandNodeCalled(name)
{
    var top = document.getElementsByTagName("body").item(0).getElementsByTagName("div").item(0);

    if(name) {
      collapseAllNodes();
    }

    //debugWindow.document.writeln(document.getElementsByTagName("percentage").item(0));
    //document.getElementsByName("percentage").item(0).firstChild.nodeValue = "foo";
    //setTimeout("doExpandNodeCalled('" + name + "', '0');", 10);
    doExpandNodeCalled(name, 0);
}



function clickHandler (evt)
{
	var elt;


  //debugWindow = window.open("","debugWin","toolbar=no,scrollbar=yes,width=300, height=400");


	if (document.layers)
		elt = evt.target;
	else if (window.event && window.event.srcElement)
	{
		elt = window.event.srcElement;
		evt = window.event;
	}
	else if (evt && evt.stopPropagation)
		elt = evt.target;


	if(!elt.className && elt.parentNode)
		elt = elt.parentNode;

  if(elt.className == 'details') {
    toggleTable(elt);
  }
  else {
	  if (elt.parentNode && elt.parentNode.className == 'expansionIcon')	// toggle
		  elt = elt.parentNode;
  	else if (elt.className != 'expansionIcon') {	// Clicked elsewhere
	  	return;
    }

  	while (elt != null && elt.tagName != 'DIV') {	
   	  elt = elt.parentNode;
    }

	
  	toggleRow(elt);
  }


	return false;
}




if (document.layers)
{
	document.captureEvents (Event.MOUSEUP);
	document.onmouseup = clickHandler;
}
else if (document.attachEvent)
{
	document.attachEvent('onclick', clickHandler);
}
else if (document.addEventListener)
{
	document.addEventListener('click', clickHandler, false);
}
else 
	document.onclick = clickHandler;


